Subject: Re: d80211: ieee80211_hw handlers in atomic context

From: Jan Kiszka <[email-masked]>
Date: Wed, 04 Oct 2006 18:31:17 +0200

Ivo van Doorn wrote:
> Hi,
> 
>> Ivo told me about a patch for d80211 that moved certain timers to thread
>> context, effectively avoiding to call config from timer handlers, but I
>> didn't find any trace yet. Is there some modification in this direction
>> already scheduled? I'm not necessarily looking for work, at best I would
>> just enjoy to use it. ;)
> 
> I have found the actual patch:
> [PATCH 1/5] d80211: make sleeping in hw->config possible
> And was send on august 1st by Jiri to the netdev list.
> It was based on a patch by Michael Buesch.

Ah, looks like I didn't dug thoroughly enough.

Anyway, this means my BUG proved the patch's claim wrong :o), at least
one atomic gremlin is left:

ieee80211_sta_timer ->
ieee80211_sta_find_ibss ->
ieee80211_sta_join_ibss ->
ieee80211_ioctl_siwfreq ->
ieee80211_hw_config

Anyone already an idea how to fix it?

Jan